/***************************************************************************
 *   Copyright (C) %{CURRENT_YEAR} by %{AUTHOR} <%{EMAIL}>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef DANBOORU_CLIENTVIEW_H
#define DANBOORU_CLIENTVIEW_H

#include "ui_danbooruclientview.h"

#include "kurl.h"

#include <QWidget>

class QTimer;

namespace Danbooru {

    class DanbooruPostModel;
    class DanbooruPostDelegate;
    class DanbooruService;

    /**
     * This is the main view class for danbooru_client.  Most of the non-menu,
     * non-toolbar, and non-statusbar (e.g., non frame) GUI code should go
     * here.
     *
     * @short Main view
     * @author %{AUTHOR} <%{EMAIL}>
     * @version %{VERSION}
     */

    class DanbooruClientView : public QWidget, public Ui::DanbooruClientView
    {
        Q_OBJECT

    public:
        /**
         * Default constructor
         */
        DanbooruClientView(QWidget *parent=0);

        /**
         * Destructor
         */
        virtual ~DanbooruClientView();

    private Q_SLOTS:
        void slotHandleDownload(QUrl);
        void slotHandleView(QUrl);

    private:
        DanbooruPostModel* m_model;
        DanbooruPostDelegate* m_delegate;
        DanbooruService* m_service;

        QTimer* m_timer;

};

} // namespace Danbooru

#endif // danbooru_clientVIEW_H
